# Introduction

This example distributes the partitioned MNIST data across multiple ranks
for truly data distributed training of a shallow Artificial Neural Network for 
handwritten digit classification.

The Horovod framework is used for seamless distributed training. However,
instead of distributing epochs, this example distributes data amongst the
ranks, so that each rank contributes training based on its local subset of
the training data.

# Notes

The `mnist_data_distributed.py` program requires the [`hpc4neuro.distribution`](
https://gitlab.version.fz-juelich.de/hpc4ns/hpc4neuro#1-hpc4neurodistribution)
module for distribution of training data filenames across multiple ranks. Please 
follow the steps below to install this package before submitting the training 
job.

1.  Change to the source directory for this sample, i.e., to `dl_on_supercomputers/training_data_distribution` 
2.  Load the system-wide Python module: `module load Python/3.8.5`    
3.  Install the `hpc4neuro` package: 

    `pip install --user git+https://gitlab.version.fz-juelich.de/hpc4ns/hpc4neuro.git`

**Note:** A maximum of eight ranks can be used to run `mnist_data_distributed.py`, 
as there are eight training files.
